#Calcul des heures de lever et de coucher du Soleil, selon la date indiquée par l'utilisateur
from math import sin,  asin
import numpy as np
import pandas as pd

#variables initiales :-----------------------------------
Nmois=[31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]#nombre de jours par mois
nomsmois=["janvier", "février", "mars", "avril", "mai", "juin", "juillet", "août", "septembre", "octobre", "novembre", "décembre"]

J=0#rang du jour dans l'année

donnees=pd.read_csv('EdTimcce.csv', delimiter='\t')
eqtemps=donnees["edt"]
#---------------------------------------------------------

#Récupération des données utilisateur :----------------------
print('Quelle est la date ? (ex. 5 juin)')
date=input()
print('Quelle est la latitude (en degrés) ?')
latitude=float(input())
latitude=np.radians(latitude)
print("Quelle est la longitude (en degrés, positive vers l'Est, négative vers l'Ouest) ?")
longitude=float(input())
print("Fuseau horaire +1 (heure d'hiver) ou +2 (heure d'été) ?")
F=float(input())
#-------------------------------------------------------------------------------------
jour=float(date.split()[0])
mois=date.split()[1]

#Définition des fonctions : -----------------------------------------------------------------
def numerodumois(m):#retourne le numéro du mois donné, de 1 à 12
    nummois=0#numéro du mois de 1 à 12
    for i in range(0, 12):
        if nomsmois[i]==m:
            nummois=i+1
    return nummois

def rang(jo, m):#calcule et renvoie le rang du jour dans l'année (entre 1 et 365)
    i=0
    Rang=0
    while i < m-1 :
        Rang=Rang+Nmois[i]
        i=i+1
    Rang=Rang+jo
    return Rang
    
def levercoucher(lati, decl):#calcule les heures de lever et coucher du Soleil
    Hzero=np.degrees(np.arccos(-np.tan(lati)*np.tan(np.radians(decl))))
    return 12-Hzero/15, 12+Hzero/15

def base60(H):#transforme une heure décimale en heures : minutes
    Hh=int(H)
    Hminutes=round(60*(H-Hh))
    return Hh, Hminutes

#Equation du temps

def edtemps(n):
    return eqtemps[n-1]/60

def corrlongitude(x):
    return x*4/60#à raison de 4 minutes par degré, puis conversion en heures
#------------------------------------------------------------------------------------

J=rang(jour, numerodumois(mois))

declinaison=np.degrees(asin(sin(np.radians(23.44))*sin(np.radians(360*(J-81)/365.2422))))

L, C=levercoucher(latitude, declinaison)

L=L-corrlongitude(longitude)
C=C-corrlongitude(longitude)

Lh, Lminutes=base60(L)
Ch, Cminutes=base60(C)

print("En heure solaire locale, le Soleil se lève à : ", Lh, " h", Lminutes, " min et se couche à ", Ch,  " h", Cminutes, "min.")

#corrections de l'équation du temps et du fuseau horaire :
J=int(J)
L=L+edtemps(J)+F
C=C+edtemps(J)+F

Lh, Lminutes=base60(L)
Ch, Cminutes=base60(C)

print("En heure légale, le Soleil se lève à : ", Lh, " h", Lminutes, " min et se couche à ", Ch,  " h", Cminutes, "min.")
